jjb: Add env and os details printing to build jobs
[lttng-ci.git] / scripts / babeltrace / build.sh
index b6590a78b9323c358990d1468a2db8910c27d790..a9ad856d344b837c1fac8f8c77d6955233a9d24d 100755 (executable)
@@ -1,7 +1,7 @@
-#!/bin/bash -exu
+#!/bin/bash
 #
 # Copyright (C) 2015 Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
-#               2016-2019 Michael Jeanson <mjeanson@efficios.com>
+# Copyright (C) 2016-2020 Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,6 +16,8 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
+set -exu
+
 # Version compare functions
 vercomp () {
     set +u
@@ -69,7 +71,18 @@ verne() {
     [ "$res" -ne "0" ]
 }
 
-# Required parameters
+failed_configure() {
+    # Assume we are in the configured build directory
+    echo "#################### BEGIN config.log ####################"
+    cat config.log
+    echo "#################### END config.log ####################"
+    exit 1
+}
+
+
+# Required variables
+WORKSPACE=${WORKSPACE:-}
+
 arch=${arch:-}
 conf=${conf:-}
 build=${build:-}
@@ -78,11 +91,11 @@ cc=${cc:-}
 
 SRCDIR="$WORKSPACE/src/babeltrace"
 TMPDIR="$WORKSPACE/tmp"
-PREFIX="$WORKSPACE/build"
+PREFIX="/build"
 
-# Create install and tmp directories
-rm -rf "$PREFIX" "$TMPDIR"
-mkdir -p "$PREFIX" "$TMPDIR"
+# Create tmp directory
+rm -rf "$TMPDIR"
+mkdir -p "$TMPDIR"
 
 export TMPDIR
 export CFLAGS="-g -O2"
@@ -155,8 +168,6 @@ sol10-i386)
     export MAKE=gmake
     export TAR=gtar
     export NPROC=gnproc
-    export BISON=bison
-    export YACC="$BISON -y"
     export PATH="/opt/csw/bin:/usr/ccs/bin:$PATH"
     export CPPFLAGS="-I/opt/csw/include"
     export LDFLAGS="-L/opt/csw/lib -R/opt/csw/lib"
@@ -164,28 +175,39 @@ sol10-i386)
     export PYTHON="python3"
     export PYTHON_CONFIG="python3-config"
     ;;
+
 sol11-i386)
     export MAKE=gmake
     export TAR=gtar
     export NPROC=nproc
-    export PATH="$PATH:/usr/perl5/bin"
+    export PATH="/opt/csw/bin:$PATH:/usr/perl5/bin"
     export LD_ALTEXEC=/usr/bin/gld
     export LD=/usr/bin/gld
     export PYTHON="python3"
     export PYTHON_CONFIG="python3-config"
+    export PKG_CONFIG_PATH="/usr/lib/pkgconfig"
     ;;
+
 macosx)
     export MAKE=make
     export TAR=tar
     export NPROC="getconf _NPROCESSORS_ONLN"
-    export BISON="bison"
-    export YACC="$BISON -y"
     export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
-    export CFLAGS="$CFLAGS -I/opt/local/include"
+    export CPPFLAGS="-I/opt/local/include"
     export LDFLAGS="-L/opt/local/lib"
     export PYTHON="python3"
     export PYTHON_CONFIG="python3-config"
     ;;
+
+cygwin)
+    export MAKE=make
+    export TAR=tar
+    export NPROC=nproc
+    export PYTHON="python3"
+    export PYTHON_CONFIG="python3-config"
+    rebase_dll=1
+    ;;
+
 *)
     export MAKE=make
     export TAR=tar
@@ -195,6 +217,10 @@ macosx)
     ;;
 esac
 
+# Print build env details
+print_os || true
+print_tooling || true
+
 # Enter the source directory
 cd "$SRCDIR"
 
@@ -203,14 +229,16 @@ cd "$SRCDIR"
 
 # Get source version from configure script
 eval "$(grep '^PACKAGE_VERSION=' ./configure)"
+PACKAGE_VERSION=${PACKAGE_VERSION//\-pre*/}
 
 # Enable dev mode by default for BT 2.0 builds
 export BABELTRACE_DEBUG_MODE=1
 export BABELTRACE_DEV_MODE=1
 export BABELTRACE_MINIMAL_LOG_LEVEL=TRACE
 
-# Set configure options for each build configuration
-CONF_OPTS=()
+# Set configure options and environment variables for each build
+# configuration.
+CONF_OPTS=("--prefix=$PREFIX")
 case "$conf" in
 static)
     echo "Static lib only configuration"
@@ -260,11 +288,12 @@ min)
 esac
 
 # Build type
-# oot : out-of-tree build
-# dist: build via make dist
-# *   : normal tree build
+# oot     : out-of-tree build
+# dist    : build via make dist
+# oot-dist: build via make dist out-of-tree
+# *       : normal tree build
 #
-# Make sure to move to the build dir and run configure
+# Make sure to move to the build directory and run configure
 # before continuing.
 case "$build" in
 oot)
@@ -274,7 +303,7 @@ oot)
     builddir=$(mktemp -d)
     cd "$builddir"
 
-    "$SRCDIR/configure" --prefix="$PREFIX" "${CONF_OPTS[@]}"
+    "$SRCDIR/configure" "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 dist)
@@ -282,7 +311,7 @@ dist)
 
     # Run configure and generate the tar file
     # in the source directory
-    ./configure
+    ./configure || failed_configure
     $MAKE dist
 
     # Create and enter a temporary build directory
@@ -293,7 +322,8 @@ dist)
     # ignore the first directory level
     $TAR xvf "$SRCDIR"/*.tar.* --strip 1
 
-    ./configure --prefix="$PREFIX" "${CONF_OPTS[@]}"
+    # Build in extracted source tree
+    ./configure "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 oot-dist)
@@ -304,7 +334,7 @@ oot-dist)
     cd "$builddir"
 
     # Run configure out of tree and generate the tar file
-    "$SRCDIR/configure"
+    "$SRCDIR/configure" || failed_configure
     $MAKE dist
 
     dist_srcdir="$(mktemp -d)"
@@ -320,12 +350,12 @@ oot-dist)
 
     # Run configure from the extracted distribution tar,
     # out of the source tree
-    "$dist_srcdir/configure" --prefix="$PREFIX" "${CONF_OPTS[@]}"
+    "$dist_srcdir/configure" "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 *)
     echo "Standard in-tree build"
-    ./configure --prefix="$PREFIX" "${CONF_OPTS[@]}"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
     ;;
 esac
 
@@ -333,34 +363,40 @@ esac
 
 # BUILD!
 $MAKE -j "$($NPROC)" V=1
-$MAKE install
+
+# Force rebase DLL address mapping
+if [ "${rebase_dll:-}" == "1" ]; then
+       find . -name "*.dll" -print0 | xargs -0 rebase -O -v
+fi
+
+# Install in the workspace
+$MAKE install DESTDIR="$WORKSPACE"
 
 # Run tests, don't fail now, we want to run the archiving steps
-set +e
-$MAKE --keep-going check
-ret=$?
-set -e
+failed_tests=0
+$MAKE --keep-going check || failed_tests=1
 
 # Copy tap logs for the jenkins tap parser before cleaning the build dir
 rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
 
+# The test suite prior to 1.5 did not produce TAP logs
+if verlt "$PACKAGE_VERSION" "1.5"; then
+    mkdir -p "$WORKSPACE/tap/no-log"
+    echo "1..1" > "$WORKSPACE/tap/no-log/tests.log"
+    echo "ok 1 - Test suite doesn't support logging" >> "$WORKSPACE/tap/no-log/tests.log"
+fi
+
 # Clean the build directory
 $MAKE clean
 
 # Cleanup rpath in executables and shared libraries
-find "$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
-find "$PREFIX/lib" -name "*.so" -exec chrpath --delete {} \;
+find "$WORKSPACE/$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
+find "$WORKSPACE/$PREFIX/lib" -name "*.so" -exec chrpath --delete {} \;
 
 # Remove libtool .la files
-find "$PREFIX/lib" -name "*.la" -exec rm -f {} \;
-
-# Clean temp dir for dist build
-if [ "$build" = "dist" ]; then
-    cd "$SRCDIR"
-    rm -rf "$builddir"
-fi
+find "$WORKSPACE/$PREFIX/lib" -name "*.la" -exec rm -f {} \;
 
-# Exit with the return code of the test suite
-exit $ret
+# Exit with failure if any of the tests failed
+exit $failed_tests
 
 # EOF
This page took 0.025656 seconds and 4 git commands to generate.